/* 4+1 Joystick plus Simon game
 * Copyright (C) 2015 David Guerrero
 * Based on Teensy Gamepad for Josh Kropf <josh@slashdev.ca>
 * Based on keyboard example for Teensy USB Development Board
 * http://www.pjrc.com/teensy/usb_keyboard.html
 * Copyright (c) 2008 PJRC.COM, LLC
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#ifndef CENTRAL_BUTTONS
#include "central_buttons.h"
#endif

extern volatile uint8_t light_buttons_values;
extern volatile uint8_t simon_start_buttons_values;

void configure_central_buttons(void)
{
    LIGHTS_DDR|= LIGHTS_PINS_MASK; //set as output
  	//CENTRAL_BUTTON_DDR=0;//set as input
  	COLOR_BUTTON_PORT|=(1<<COLOR_BUTTON);//activate pull-up
    SIMON_START_BUTTON_PORT|=(1<<SIMON_START_BUTTON);//activate pull-up
}

void wait_till_depressed_button(uint8_t x)
{
  //skip_bounces;
  while(pressed_light_button(x));
  //skip_bounces;
}

void wait_till_depressed_all_color_buttons()
{
  //skip_bounces;
  while(pressed_any_light_button);
  //skip_bounces;
}
